/*
    ObjectGraph.h

    Interface declaration of the ObjectGraph class for the KeyArcher
    application.

    Copyright (C) 2006  Saso Kiselkov

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef _OBJECTGRAPH_H_
#define _OBJECTGRAPH_H_

#import <Foundation/NSObject.h>

@interface ObjectGraph : NSObject
{
  NSArray * objects;

  unsigned int rootObjectUID;
}

- initWithKeyedArchive: (NSDictionary *) archive;

- (unsigned int) rootObjectUID;

- objectForUID: (unsigned int) UID;
- (unsigned int) numberOfObjects;

- objectAtPath: (NSString *) path;
- (NSString *) classNameForUID: (unsigned int) UID;
- (NSArray *) classInheritanceForUID: (unsigned int) UID;

@end

#endif // _OBJECTGRAPH_H_
